#Demo2.ps1
#Mise en place d'un ColoredConsoleAppender en tant qu'appender par dfaut.
#Manipulation des Couleurs
.\InitializeLG4N.ps1 
# $DebugPreference="Continue"
#Stop-log

 #On cre un nouveau logger 
$Log = Get-LogLogger "LogPowerShell"

 #Dclare les couleurs utilises par un appender coloris
[System.Collections.Hashtable[]] $Colors1=@(
   @{Level="Warn";FColor="Yellow";BColor=""},
   @{Level="Info";FColor="Cyan";BColor=""},
   @{Level="Debug";FColor="Green,HighIntensity";BColor=""},
   @{Level="Error";FColor="Red";BColor="Red,HighIntensity"}
 )
     
$Pattern = "%date{dd-MM-yyyy } %-5level - %message%newline"
  #Configure le framework avec l'appender coloris prcdement cr dans le pipeline
  #Cet appender devient l'appender par dfaut
  #Le tableau de mappage des couleurs provient d'un tableau de hashtable. 
  # la HashTable doit respecter la structure suivante :  @{Level="";FColor="";BColor=""}
New-LogColoredConsoleAppender $Colors1 $Pattern -Activate|Set-LogBasicConfigurator 
 #Notre logger reste actif mme si l'appender a t modifi.
 #Ici la chane de formatage diffre ainsi que le type de l'appender par dfaut associ au logger "LogPowerShell"   
$Log.Info("TestMessage1");

[System.Collections.Hashtable] $Colors=@{
   PSDefault=@( 
     @{Level="Warn";FColor="Yellow";BColor=""},
     @{Level="Info";FColor="Cyan";BColor=""},
     @{Level="Debug";FColor="Green";BColor=""},
     @{Level="Error";FColor="Red";BColor=""}
    )

   Testing=@(
     @{Level="Warn";FColor="Yellow";BColor=""},
     @{Level="Info";FColor="Green,HighIntensity";BColor=""},
     @{Level="Debug";FColor="Cyan";BColor=""},
     @{Level="Error";FColor="Red";BColor=""}
     @{Level="Fatal";FColor="Red";BColor="Red,HighIntensity"}
  )
 }
 #On rinitialise l'appender avec un nouveau mapping de couleurs.
 #Le tableau de mappage des couleurs provient cette fois d'un tableau de tableau de hashtable. 
 #Pour l'appel suivant on effectue le test d'existence des couleurs sur le repository par dfaut.
$Appender=New-LogColoredConsoleAppender $Colors.Testing $Pattern -Activate|Set-LogBasicConfigurator 
$Log.Info("TestMessage2");

 #Modifie le mappage des couleurs d'un niveau, dans ce cas on doit revalider 
 #les options, de l'appender modifi, par l'appel  Enable-LogAppender
 #ATTENTION selon le type de l'appender sa reconfiguration peut provoquer des effets indsirables, cf. FileAppender.
$Appender|Add-LogMappingColors $Appender @{Level="Info";FColor="red";BColor="HighIntensity"}|Enable-LogAppender
$Log.Info("TestMessage3");

Stop-Log
