# InitializeLG4N.ps1
# On doit charger la DLL du Framework avant de pouvoir rfrencer ses classes.
#
#Version 0.1 le 08/02/2009
#Laurent Dardenne


Param ( [String]$Path=$PWD )
 #Path  : Contient le nom du rpertoire o est situ la dll de log4net
 #        Par dfaut c'est le rpertoire courant.
 #        La dll inscrite dans le GAC sera prioritaire 
  
 Write-Debug ("Call : {0}" -F $MyInvocation.MyCommand)

# ------------ Fonctions diverses  ----------------------------------------------------------------------------
function global:Test-AssemblyLoaded([string] $AssemblyName=$(Throw "Test-AssemblyLoaded : le paramtre AssemblyName doit tre renseign.")) {
  #$AssemblyName est un nom court de fichier assembly (Nom.dll)
  # Test-AssemblyLoaded "log4net.dll"
 ([AppDomain]::CurrentDomain.GetAssemblies()| ?{ $_.Location -Match "$AssemblyName$"}) -ne $null
}

  # ------------- Pseudo-raccourcis ----------------------------------------------------------------------------
   #Raccourci ( PS V1 )
   #Usage :
   # $Logger = new-object (LogManager)::GetLogger($Name))
function global:LogManager {[log4net.LogManager]}
function global:LogBasicCnfg{[log4net.Config.BasicConfigurator]}
function global:LogXmlCnfg {[log4net.Config.XmlConfigurator]}
function global:LogColoredConsole {[log4net.Appender.ColoredConsoleAppender]}
function global:LogColors {[log4net.Appender.ColoredConsoleAppender+Colors]}
function global:LogLevel {[log4net.Core.Level]}
function global:LogThreadCtx {[log4net.ThreadContext]}
function global:LogGlobalCtx {[log4net.GlobalContext]}

function global:LogShorcuts { 
  #Affiche les pseudo-raccourcis ddis  Log4net
 Dir function:Log*
}

# ------------ Initialisation et Finalisation  ----------------------------------------------------------------------------

# Si l'assembly est install dans le GAC il est prioritaire mme si on appel la mthode LoadFrom
 trap [System.IO.FileNotFoundException] {Break}
 [Reflection.Assembly] $Result=$Null  
 if (!(Test-AssemblyLoaded "log4net.dll"))
 { 
   &{
     trap [System.IO.FileNotFoundException] {Continue}
     #Charge  partir du GAC
     $Result=[Reflection.Assembly]::Load("log4net, Version=1.2.10.0, Culture=neutral, PublicKeyToken=1b44e1d426115821")
    }
    #Sinon charge  partir du rpertoire indiqu
    if ($Result -eq $null) {$Result=[Reflection.Assembly]::LoadFrom( "$Path\log4net.dll")}
 }
  
Set-Alias -Scope Global -name Stop-Log -value Stop-Log4Net
Function global:Stop-Log4Net{
 #On arrte proprement le Framework de Log
  #Avec [log4net.LogManager]::Shutdown() tous les appenders sont ferms proprement, mais le repository par dfaut reste configur

  Write-Debug "Call : Stop-Log"
   #Shutdown() est appell en interne, le repository par dfaut n'est plus configur
 [log4net.LogManager]::ResetConfiguration()
}

# ----------- Suppression des objets du Wrapper -------------------------------------------------------------------------
Set-Alias -Scope Global -name Remove-Log -value Remove-WrapperLog4Net
function Remove-WrapperLog4Net([String]$Path=$PWD,
                               [Switch] $StopLog, 
                               [Switch] $Verbose) {
 #Path     : Contient le nom du rpertoire o est situ le script PackageLog4NET.ps1
 #           Par dfaut c'est le rpertoire courant.
 #StopLog  : Indique si on on arrte proprement le Framework de Log
 #
 #Verbose  : Indique si on affiche des commentaires lors de la suppression des alias et des functions 

  if ($StopLog) {Stop-Log}
   #Remove Functions
  dir function:|Where {$_ -match "^(.*)-Log*"}|remove-item -Verbose:$Verbose
   #ou TODO
    # $Lines=select-string -path PackageLog4NET.ps1 -patt "^function global:"
    #$Lines|% {[void]($_.line -match "^function global:(?<nom>[A-Za-z0-9-]+Log[A-Za-z0-9]+)");$Matches.Nom}|sort
    #plus celles de ce script 
    #Remove Alias, recherche ceux qui ne sont plus valide
  dir Alias:| Where {$_.ResolvedCommand -eq $null}|remove-item -Verbose:$Verbose
}

 #Charge les fonctions encapsulant les mthodes de Log4Net 
. .\PackageLog4NET.ps1
